<?php
/**
PBox
Customizable content widgets able to display posts, pages, links and plain text in a custom style.
2.3
Authors: Aaron Berg, Dale Taylor, Nelson Lai, Yefei Tang, Xueyan Bai, Zafor Ahmed, Fran&ccedil;ois Fortin, Lindsay Newton, Nicholas Crawford, Jairus Pryor
http://www.bankofcanada.ca/
*/

/** UNINSTALL ADMIN PAGE **/

/*  Copyright 2009 Bank of Canada (Aaron Berg, Dale Taylor, Nelson Lai, Yefei Tang, Xueyan Bai, Zafor Ahmed, Fran&ccedil;ois Fortin, Lindsay Newton)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


 
if ( !pbox_check_capabilities() ) {
	wp_die( __( 'You do not have sufficient permissions to access this page.', 'pb' ) );
}

include_once( 'pb.inc.php' ); 
global $wpdb;

// building a safe deactivation URL
$deactivate_url = get_bloginfo( 'url' ) . 
							'/wp-admin/' . 
							wp_nonce_url( 'plugins.php?action=deactivate&plugin='.PBOX_DIR_NAME.'pb.php', 
													'deactivate-plugin_'.PBOX_DIR_NAME.'pb.php' );
?>
<div class="wrap">
<div id="icon-themes" class="icon32"><br /></div>
<h2><?php _e( 'Uninstall PBox', 'pb' );?></h2>
<?php

if ( isset( $_REQUEST['action'] ) ) {
	// If the user chooses to delete all PBox data and deactivate
	if 	( $_REQUEST['action'] == 'remove_data' ) {
		check_admin_referer( 'pbox-uninstall-delete' );
		// Delete DB stuff
		
		// PBOX tables
		$wpdb->query( 'DROP TABLE `' . PBOX_TABLE . '`' );	
		$wpdb->query( 'DROP TABLE `' . PBOX_ITEM_TABLE . '`' );
		$wpdb->query( 'DROP TABLE `' . PBOX_USAGE_TABLE . '`' );	 
		$wpdb->query( 'DROP TABLE `' . PBOX_STYLE_TABLE . '`' );	 

		// PBOX options
		delete_option( 'pb_csstimestamp' );
		delete_option( 'PBox_DB' );
		delete_option( 'widget_pb' );
		
		/*
		* If X-Widgets is installed, delete data from wp-postmeta (this must be done here, 
		* because the widget_delete_option() function requires a page ID, and none 
		* can be given.
		*/
		if( class_exists( 'XWidgets' ) ) {
			$wpdb->query( "DELETE FROM $wpdb->postmeta WHERE meta_key='_xwidgets_widget_pb'" );
		}
		
		// Delete PBox style sheet
		if( file_exists( PBOX_CSS_LOC ) ) {
			unlink( PBOX_CSS_LOC );
		}
		?>
		<p><?php _e( 'All PBox data has been deleted. Please click the link below to deactivate the plugin.', 'pb' );?></p>
		<p><a href="<?php echo $deactivate_url; ?>"><?php _e( 'Deactivate plugin', 'pb' );?></a></p>
		</div>
		<?php
	}
} else {
// display instructions and handle simple deactivation without deletion
?>
<h3><?php _e( 'Deactivate plugin and <strong>RETAIN</strong> PBox data:', 'pb' ); ?></h3>
<p><?php _e( 'Choosing this option will deactivate the plugin but won\'t touch any of your Presentation Box meta data, content or styles. Deactivating through this method will allow you to reactivate PBox to its previous state.', 'pb' ) ?></p>
<p><a onclick="return confirm('<?php _e( 'Are you sure you want to deactivate the PBox plugin?', 'pb' ); ?>');" href="<?php echo $deactivate_url; ?>"><?php _e( 'Deactivate plugin and <span style="color:green;">RETAIN</span> PBox data', 'pb' );?></a></p>
<h3><?php _e( 'Deactivate plugin and <strong>DELETE</strong> PBox data', 'pb' );?></h3>
<p><?php _e( 'This option is not reversible. This option as it will remove all PBox information. This includes: ', 'pb' ) ?></p>
<ul style="list-style-type:disc;padding-left:50px">
<li><?php _e( 'All PBox tables (styles, usage, items)', 'pb' ) ?></li>
<li><?php _e( 'All references to pboxes on pages and posts', 'pb' ) ?></li>
<li><?php _e( 'The css file generated from the style panel', 'pb' ) ?></li>
<?php
if( class_exists( 'XWidgets' ) ) {
?>
<li><?php _e( 'All metadata entries generated by XWidgets for PBox', 'pb' ) ?></li>
<?php
}
?>
</ul>
<p><?php _e( 'Make sure to backup your database before performing this operation.', 'pb' ) ?></p>
<p><a onclick="return confirm('<?php _e( 'Are you sure you want to DELETE ALL PBOX DATA?', 'pb' ); ?>');" href="<?php echo wp_nonce_url( PBox::get_admin_url( 'include_pbox_uninstall','&action=remove_data' ), 'pbox-uninstall-delete' ); ?>"><?php _e( 'Deactivate plugin and <span style="color:red;">DELETE</span> PBox data', 'pb' );?></a></p>
</div>
<?php
}

